
package com.dotfile.palm.awt;

import java.awt.*;
import java.awt.event.*;


public
class		ImageIcon
extends		Canvas
	{
	protected Image  			image;
	protected int				width, height;
	protected Dimension			mDim, pDim;

	public
	ImageIcon( Image image )
		{
		super();
		this.image = image;
		}
	
	public synchronized void
	paint( Graphics g )
		{
		if ( ! this.getParent().isEnabled() ) // REVIEW - why is this here?
			return;

		if ( this.image != null )
			{
			Dimension d = this.getSize();

			int width = this.image.getWidth( this );
			int height = this.image.getHeight( this );

			int x = ( d.width - (width + 1) ) / 2;
			int y = ( d.height - (height + 1) ) / 2;

			g.drawImage( this.image, x, y, null );
			}
		}

	public boolean
	isFocusTraversable()
		{
		return false;
		}

	public void
	computeDimensions()
		{
		int width = this.image.getWidth( this );
		int height = this.image.getHeight( this );

		this.mDim = new Dimension( width, height );
		this.pDim = new Dimension( this.mDim.width, this.mDim.height );
		}

	public Dimension
	getPreferredSize()
		{
		return this.pDim;
		}

	public Dimension
	getMinimumSize()
		{
		return this.mDim;
		}

	public void
	addNotify()
		{
		super.addNotify();
		this.computeDimensions();
		}

	}
