
package com.dotfile.palm.currexc;

import java.io.*;
import palm.conduit.Log;

import com.dotfile.palm.config.HotSyncConfig;


public
class		CurrExConfig
extends		HotSyncConfig
	{
    static final String PREF_DIR = "currex";
    static final String PROPS_FILE = "currex.prf";
    static final String DEFAULT_URL = "http://currex.sourceforge.net/cupdate.pdb";

	/**
	 * Flag that determines if proxy connection is used.
	 */
	boolean		debug;

	/**
	 * The URL of the Cupdate.pdb download.
	 */
	String		updateURL;

	/**
	 * Flag that determines if proxy connection is used.
	 */
	boolean		useProxy;

	/**
	 * The hostname of the proxy.
	 */
	String		proxyHost;

	/**
	 * The port number of the proxy.
	 */
	int			proxyPort;


	public
	CurrExConfig( String configPath )
		{
		super( configPath );
		// Do NOT init fields here, since the superclass calls
		// our load method so they are already filled in!!
		}

	/**
	 * Returns the name of the subdirectory where
	 * we to store our settings the other files.
	 */

	public String
	getPropertyDirName()
		{
		return PREF_DIR;
		}

	public boolean
	getDebug()
		{
		return this.debug;
		}

	public void
	setDebug( boolean debug )
		{
		this.debug = debug;
		}

	public String
	getPropertyFileName()
		{
		return PROPS_FILE;
		}

	public String
	getUpdateURL()
		{
		return this.updateURL;
		}

	public void
	setUpdateURL( String updateURL )
		{
		this.updateURL = updateURL;
		}

	public boolean
	getUseProxy()
		{
		return this.useProxy;
		}

	public void
	setUseProxy( boolean useProxy )
		{
		this.useProxy = useProxy;
		}

	public String
	getProxyHost()
		{
		return this.proxyHost;
		}

	public void
	setProxyHost( String proxyHost )
		{
		this.proxyHost = proxyHost;
		}

	public int
	getProxyPort()
		{
		return this.proxyPort;
		}

	public void
	setProxyPort( int proxyPort )
		{
		this.proxyPort = proxyPort;
		}

	public void
	loadDefaultConfig()
		{
		this.setSyncAction( HOTSYNC_ACTION_PC2HH );
		this.debug = false;
		this.useProxy = false;
		this.proxyPort = 8080;
		this.proxyHost = "";
		this.updateURL = DEFAULT_URL;
		}

	public void
	loadConduitConfig( DataInputStream dataIn )
		throws IOException
		{
		try {
			this.debug = dataIn.readBoolean();
			this.useProxy = dataIn.readBoolean();
			this.proxyPort = dataIn.readInt();
			this.proxyHost = dataIn.readUTF();
			this.updateURL = dataIn.readUTF();
			}
		// If there is an IOException, then this is probably
		// an old prefs file, so just default things to recover.
		catch ( IOException ex )
			{
			this.debug = false;
			this.useProxy = false;
			this.proxyPort = 8080;
			this.proxyHost = "";
			this.updateURL = DEFAULT_URL;
			}
		}

	public void
	saveConduitConfig( DataOutputStream dataOut )
		throws IOException
		{
		dataOut.writeBoolean( this.debug );
		dataOut.writeBoolean( this.useProxy );
		dataOut.writeInt( this.proxyPort );
		dataOut.writeUTF( this.proxyHost );
		dataOut.writeUTF( this.updateURL );
		}

	}
